#include <TEA5767.h>
#include <Wire.h>
TEA5767 radio = TEA5767(); 

int aState;                 //State of the first encoder switch contact
int bState;                 //State of the second encoder switch contac
int outputA = 7;            //The pin connected to the A contact on the encoder switch
int outputB = 8;            //The pin connected to the B contact on the encoder switch
float frequency = 99.10;    //The initial frequency value

void setup() {
Wire.begin(); 
Serial.begin(115200);           //Intitalize serial communications for serial monitor window as needed
radio.setFrequency(frequency);  //Set the radio to the frequency value     
radio.setStereoNC(true);        //Turn on noise cancellation
radio.setMuted(false);          //un-mute the radio sound
pinMode (outputA,INPUT);        //Set rotary encoder A pin to input
pinMode (outputB,INPUT);        //Set rotary encoder B pin to input

}

void loop() {
  Serial.print("Frequency = ");
  Serial.println(frequency);
  aState = digitalRead(outputA);                    //Check the state of rotary encoder contact A
  bState = digitalRead(outputB);                    //Check the state of rotary encoder contact A
                   
    if (aState == 1 && bState == 0){                //If rotary encoder is turning clockwise
    
    while (aState == 1 || bState == 1) {            //While switch is in the state where both contacts A and B are high
    aState = digitalRead(outputA);                  //Continue checking state of contact A
    bState = digitalRead(outputB);                  //Continue checking state of contact B
}

frequency = frequency + 0.1;                        //Increase frequency by 100Khz
frequency = constrain(frequency, 88.0, 108.1);      //Limit frequency range to 88 - 108.1 MHz

if (frequency > 108.0) {frequency = 88.0;}          //If frequency exceeds upper limit of 108 MHz roll it back to bottom of range
radio.setFrequency(frequency);                      //Set the radio to the new frequency

}
          
    if (bState == 1 && aState == 0){                //If rotary encoder is turning counter clockwise 
 
    while (aState == 1 || bState == 1) {            //While switch is in the state where both contacts A and B are high
    aState = digitalRead(outputA);                  //Continue checking state of contact A
    bState = digitalRead(outputB);                  //Continue checking state of contact B    
}
    
frequency = frequency - 0.1;                        //Decrease frequency by 100Khz
frequency = constrain(frequency, 87.9, 108.0);      //Limit frequency range to 87.9 - 108 MHz
    
if (frequency < 88.0) {frequency = 108.0;}          //If frequency exceeds lower limit of 108 MHz roll it back to top of range
radio.setFrequency(frequency);                      //Set the radio to the new frequency

}
 }


 
